<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class PercorreDependencia {

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_nrEstruturaTrab;
    private $_mesCompetencia;

    private $_vinculo;

    private $_dsInicio;
    private $_dsFim;
    private $_dsOrdem;



    public function __construct($nrFormulario, Parametros $parametro){

        $this->_nrOrg = $parametro->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $parametro->getNrOrgPadrao();
        $this->_nrEstruturaTrab = $parametro->getNrEstrutTrab();
        $this->_mesCompetencia = $parametro->getMesCompetencia();

        $this->_buscaDadosFormulario($nrFormulario);

        Inicializa::Container($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);
        $this->_vinculo = TkDI::getContainer()->vinculom;

    }


    public function percorre(){

        $vinculos = $this->_vinculo->retornaVinculosAtivosMesCompetencia(
            $this->_nrOrg, $this->_mesCompetencia, $this->_dsInicio, $this->_dsFim, $this->_dsOrdem, false,
            $this->_nrEstruturaTrab
        );

        $dependencia = new Dependencia($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);

        foreach ($vinculos as $vinculo) {
            $dependencia->analisaDependencia($vinculo);
        }

    }

    /**
     * @param $nrFormulario
     * @return void
     *
     * @author - alessandrobartels- 29/05/2012
     */
    private function _buscaDadosFormulario($nrFormulario){
        $formulario = new FpaFormdependeEntity();
        $formulario->carregaDadosFormularioDependencia($this->_nrOrg, $nrFormulario);

        $this->_dsInicio = $formulario->getDsinicio();
        $this->_dsFim = $formulario->getDsfim();
        $this->_dsOrdem = $formulario->getDsordem();

        unset($formulario);
        
    }


}