<?php

/**
 * GepAtividade
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     robertomartins - 16/05/2011 13:42:43 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepAtividade extends DaoGepAtividade
{
    /**
     * Situa??es
     */
    const SITUACAO_PENDENTE = 'PENDENTE';
    const SITUACAO_ANDAMENTO = 'ANDAMENTO';
    const SITUACAO_INTERROMPIDA = 'INTERROMPIDA';
    const SITUACAO_REALIZADA = 'REALIZADA';
    const SITUACAO_CONCLUIDA = 'CONCLUIDA';

    /**
     * Retorna dados de uma atividade.
     *
     * @param integer $nrorg       N?mero da Organiza??o.
     * @param integer $nratividade N?mero da Atividade.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaAtividade($nrorg, $nratividade){

        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRATIVIDADE = ?',
                array(
                 $nrorg,
                 $nratividade,
                )
            );

            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Retorna dados de uma atividade.
     *
     * @param integer $parcnegocio Cod do parceiro.
     *
     * @return string
     */
    public static function retornaConsultaAtividades($parcnegocio){
    	$nrorg = Ambiente::getNrorg();
    	$sql = "
     SELECT * FROM (
        SELECT GEP_ATIVIDADE.DTINICIOPLANEJADO,
        GEP_ATIVIDADE.DTFIMPLANEJADO,
        GEP_ATIVIDADE.NRATIVIDADE,
        GEP_ATIVIDADE.DTFINALIZACAO,
        ATP.NMATIVIDADEPROC,
        GEP_ATIVIDADE.NRATIVIDADEPROC,
        GEP_ATIVIDADE.IDSITUACAOATIV,
        GEP_ATIVIDADE.TXATIVIDADE,
        GEP_ATIVIDADE.TXOBSERVATIVIDADE,
        GEP_ATIVIDADE.DSREFERENCIAATIV,
        GEP_ATIVIDADE.NRORG,
        SOL.DSREFERENCIASOLI,
        SOL.NRSOLICITACAO,
        PN.NMPRINCIPALPARC
      FROM GEP_ATIVIDADE
      JOIN GEP_SOLICITACAO SOL ON GEP_ATIVIDADE.NRSOLICITACAO = SOL.NRSOLICITACAO
        AND GEP_ATIVIDADE.NRORG = SOL.NRORG
                  JOIN  PARCNEGOCIO PN ON SOL.NRPARCOPERSOLI = PN.NRPARCNEGOCIO
      LEFT JOIN GEP_ATIVIDADEPROC ATP ON GEP_ATIVIDADE.NRATIVIDADEPROC = ATP.NRATIVIDADEPROC
        AND GEP_ATIVIDADE.NRORG = ATP.NRORG
      WHERE GEP_ATIVIDADE.NRPARCOPERRESP = %d
        AND GEP_ATIVIDADE.NRORG = %d
        AND GEP_ATIVIDADE.IDSITUACAOATIV <> 'CONCLUIDA'
				) GEP_ATIVIDADE
    WHERE WHERE_PLACEHOLDER AND FILTER_PLACEHOLDER
    ORDER BY NRATIVIDADE DESC
    ";

        //Melhor desempenho do banco quando os tipos NUMBER sao inteiros (nao forca a conversao pelo oracle).
        $nrorg = (int) $nrorg;
        $parcnegocio = (int)$parcnegocio;
        $sql = sprintf($sql, $parcnegocio, $nrorg);
        return $sql;
    }


	/**
     * Altera o status de uma atividade.
     *
     * @param string  $upidsituacaotiv Situacao da atividade.
     * @param int $nratividade Codigo da atividade.
     * @param int $nrorg Codigo da organizacao.
     *
     *
     * @return boolean
     */
	public static function alteraStatusAtvidade(
		$upidsituacaotiv,
		$nrorg,
		$nratividade
	) {
		$db = \Setforms2\Runtime\Connection::getInstance()->getConn();
		$query = $db->createQuery()
					->update('GepAtividade')
					->set('IDSITUACAOATIV', '?', $upidsituacaotiv)
					->addWhere('NRATIVIDADE  = ?', $nratividade)
					->addWhere('NRORG  = ?', $nrorg);

		$result = $query->execute();
		
		return ($result instanceof Doctrine_Adapter_Statement) === true ? true : false;
	}


    /*
     * Retorna a atividade que esta com a situacao em interrompida.
     *
     * @param string $cdfilial   Codigo da filial.
     * @param string $cdoperresp Operador responsavel.
     *
     * @return Ambigous <TkModel, unknown, mixed, NULL>
     */
    static public function retornaAtividadesInterrompidas($nrorg, $cdoperresp){
		try {
			$select = 'NRPARCOPERRESP = ? AND IDSITUACAOATIV = ? AND NRORG = ?';
			$obj = self::getObjectsByWhereAsArray(
			$select,
			array(
			    $cdoperresp,
                'INTERROMPIDA',
                $nrorg,
			)
			);

            $return = is_array($obj) ? $obj : array();
			return $return;

		} catch (Exception $e){
			showClassError($e, __FUNCTION__, __LINE__);
		}

	}


    static public function retornaAtividadesPendentes($nrorg, $cdoperresp){
		try {
			$select = 'NRPARCOPERRESP = ? AND IDSITUACAOATIV = ? AND NRORG = ?';
			$obj = self::getObjectsByWhereAsArray(
			$select,
			array(
			    $cdoperresp,
                GepAtividade::SITUACAO_PENDENTE,
                $nrorg,
			)
			);

            $return = is_array($obj) ? $obj : array();
			return $return;

		} catch (Exception $e){
			showClassError($e, __FUNCTION__, __LINE__);
		}

	}


    /**
     * Consulta atividades.
     *
     * @param  integer $nrorg         Numero da organizacao.
     * @param  integer $nrparcnegocio Numero do parceiro de negocio.
     *
     * @return string  $query         Query da consulta.
     */
    public static function consultaAtividades($nrorg, $nrparcnegocio){
        $query = "SELECT
                  GEP_ATIVIDADE.NRATIVIDADE,
                  GEP_ATIVIDADE.DSREFERENCIAATIV,
                  OBS.NRPARCNEGOCIO AS NRPARCNEGOBSERV,
                  OBS.TXOBSERVACAO,
                  GEP_ATIVIDADE.IDSITUACAOATIV,
                  GEP_ATIVIDADE.NRATIVIDADEPROC,
                  ATP.NMATIVIDADEPROC AS NRATIVIDADEPROC__LABEL,
                  GEP_ATIVIDADE.NRSOLICITACAO,
                  SL.DSREFERENCIASOLI AS NRSOLICITACAO__LABEL,
                  GEP_ATIVIDADE.NRPARCNEGOSOLI,
                  PNEGOSOLI.NMPRINCIPALPARC AS NRPARCNEGOSOLI__LABEL,
                  GEP_ATIVIDADE.NRPARCOPERSOLI,
                  POPERSOLI.NMPRINCIPALPARC AS NRPARCOPERSOLI__LABEL,
                  GEP_ATIVIDADE.NRPARCOPERRESP,
                  POPERRESP.NMPRINCIPALPARC AS NRPARCOPERRESP__LABEL,
                  GEP_ATIVIDADE.TXATIVIDADE,
                  GEP_ATIVIDADE.DTINICIOPLANEJADO,
                  GEP_ATIVIDADE.DTFIMPLANEJADO,
                  CASE
                    WHEN APR.DTTOTAL IS NULL
                    THEN ''
                    ELSE concat(concat(floor(APR.DTTOTAL),':'),lpad((APR.DTTOTAL - floor(APR.DTTOTAL)) * 60, 2, 0))
                  END AS QTHORASAPROPRIADAS,
                  GEP_ATIVIDADE.QTHORASPLANEJADA,
                  CASE
                    WHEN QTHORASPLANEJADA IS NULL
                    THEN ' '
                    ELSE concat(concat(floor(qthorasplanejada),':'),lpad((qthorasplanejada - floor(qthorasplanejada)) * 60, 2, 0))
                  END AS QTHORASPLANEJADA_LABEL,
                  APR.DTINICIOAPROPRIACAO,
                  GEP_ATIVIDADE.DTFINALIZACAO,
                  GEP_ATIVIDADE.DTCONCLUSAO,
                  GEP_ATIVIDADE.NRPARCOPERCONC,
                  POPERCONC.NMPRINCIPALPARC AS NRPARCOPERCONC__LABEL,
                  GEP_ATIVIDADE.IDATIVO,
                  GEP_ATIVIDADE.DTULTATU,
                  GEP_ATIVIDADE.CDOPERULTATU,
                  OPERULTATU.NMOPERADOR AS CDOPERULTATU__LABEL,
                  GEP_ATIVIDADE.NRORGULTATU,
                  GEP_ATIVIDADE.DTINCLUSAO,
                  GEP_ATIVIDADE.CDOPERINCLUSAO,
                  OPERINCLUSAO.NMOPERADOR AS CDOPERINCLUSAO__LABEL,
                  GEP_ATIVIDADE.NRORGINCLUSAO,
                  GEP_ATIVIDADE.NRORG,
                  GEP_ATIVIDADE.TXOBSERVATIVIDADE

                FROM GEP_ATIVIDADE

                LEFT JOIN GEP_OBSERVACAOATIV OBS
                ON GEP_ATIVIDADE.NRATIVIDADE = OBS.NRATIVIDADE
                AND GEP_ATIVIDADE.NRORG      = OBS.NRORG
                AND OBS.NRPARCNEGOCIO = $nrparcnegocio

                LEFT JOIN
                (SELECT GEP_ATIVIDADE.NRATIVIDADE,
                        TRUNC((SUM(APR.DTFIMAPROPRIACAO - APR.DTINICIOAPROPRIACAO)*24),2) AS DTTOTAL,
                         MIN(APR.DTINICIOAPROPRIACAO) AS DTINICIOAPROPRIACAO,
                        GEP_ATIVIDADE.NRORG
                 FROM GEP_ATIVIDADE
                 LEFT JOIN GEP_APROPRIACAO APR
                 ON GEP_ATIVIDADE.NRATIVIDADE = APR.NRATIVIDADE
                 AND GEP_ATIVIDADE.NRORG      = APR.NRORG
                 GROUP BY GEP_ATIVIDADE.NRATIVIDADE, GEP_ATIVIDADE.NRORG) APR
                ON APR.NRATIVIDADE = GEP_ATIVIDADE.NRATIVIDADE
                AND APR.NRORG = GEP_ATIVIDADE.NRORG

                LEFT JOIN PARCNEGOCIO PNEGOSOLI
                ON PNEGOSOLI.NRPARCNEGOCIO = GEP_ATIVIDADE.NRPARCNEGOSOLI
                AND PNEGOSOLI.NRORG        = GEP_ATIVIDADE.NRORG

                LEFT JOIN PARCNEGOCIO POPERSOLI
                ON POPERSOLI.NRPARCNEGOCIO = GEP_ATIVIDADE.NRPARCOPERSOLI
                AND POPERSOLI.NRORG        = GEP_ATIVIDADE.NRORG

                LEFT JOIN PARCNEGOCIO POPERRESP
                ON POPERRESP.NRPARCNEGOCIO = GEP_ATIVIDADE.NRPARCOPERRESP
                AND POPERRESP.NRORG        = GEP_ATIVIDADE.NRORG

                LEFT JOIN PARCNEGOCIO POPERCONC
                ON POPERCONC.NRPARCNEGOCIO = GEP_ATIVIDADE.NRPARCOPERCONC
                AND POPERCONC.NRORG        = GEP_ATIVIDADE.NRORG

                LEFT JOIN GEP_SOLICITACAO SL
                ON SL.NRSOLICITACAO = GEP_ATIVIDADE.NRSOLICITACAO
                AND SL.NRORG           = GEP_ATIVIDADE.NRORG

                LEFT JOIN GEP_ATIVIDADEPROC ATP
                ON ATP.NRATIVIDADEPROC = GEP_ATIVIDADE.NRATIVIDADEPROC
                AND ATP.NRORG             = GEP_ATIVIDADE.NRORG

                LEFT JOIN OPERADOR OPERINCLUSAO
                ON OPERINCLUSAO.CDOPERADOR = GEP_ATIVIDADE.CDOPERINCLUSAO
                AND OPERINCLUSAO.NRORG = GEP_ATIVIDADE.NRORG

                LEFT JOIN OPERADOR OPERULTATU
                ON OPERULTATU.CDOPERADOR = GEP_ATIVIDADE.CDOPERULTATU
                AND OPERULTATU.NRORG = GEP_ATIVIDADE.NRORG

                WHERE GEP_ATIVIDADE.NRORG = $nrorg
                AND   FILTER_PLACEHOLDER
                AND   WHERE_PLACEHOLDER

                ORDER BY GEP_ATIVIDADE.NRATIVIDADE
        ";

        return $query;
    }


	/**
     * Retorna dados de uma atividade em andamento.
     *
     * @param integer $cdoperresp C?digo do operador.
     *
     * @return PlanativtareEntity|boolean
     */
    static public function retornaAtividadeAndamento($nrorg, $nrparcnegocio){
		try {
		    $return = false;
			$select = 'NRPARCOPERRESP = ? AND IDSITUACAOATIV = ? AND NRORG = ?';
			$obj = self::getObjectByWhere(
			$select,
			array(
			    $nrparcnegocio ,
                GepAtividade::SITUACAO_ANDAMENTO,
                $nrorg,
			)
			);

			if ($obj instanceof GepAtividadeEntity)
			    $return = $obj->toArray();

			return $return;

		} catch (Exception $e){
			showClassError($e, __FUNCTION__, __LINE__);
		}


	}

    public static function getObjectsByWhereAsArray($where, $params = array(), $order_by = null)
    {
        $result = self::getDaoObjectsByWhere($where, $params, $order_by);

        if ($result) {
            $objects = array();

            foreach ($result as $object) {
                $objects[] = self::getEntityObjectFromDao($object)->toArray();
            }

            return $objects;
        }
        return null;
    }

	/**
     * Exclui Atividade por n?mero de atividade.
     *
     * @param integer $nratividade N?mero da Atividade.
     * @param integer $nrorg       N?mero da Organiza??o.
     *
     * @return boolean
     */
    public static function excluiAtividade($nratividade, $nrorg){
        try {
            /*
            $db = TkDbAdapter::getWorkConnection();
            $exclusao = $db->createQuery()
                			->delete('GEP_ATIVIDADE')
                			->where("NRORG = '".$nrorg."'")
                			->addWhere("NRATIVIDADE = '".$nratividade."'");
            $db->execute($exclusao);
            return true;
            */
            $sql = "DELETE GEP_ATIVIDADE
                    WHERE NRORG = $nrorg
                    AND NRATIVIDADE = $nratividade";
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);
            return true;
        } catch(Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

	/**
     * Altera data fim plenejado.
     *
     * @param string  $dtfimplanejado Data fim planejado.
     * @param integer $nratividade    Numero da atividade.
     *
     * @throws Exception
     *
     * @return boolean
     */
    static public function alteraDtfimplanejado($dtfimplanejado, $nratividade){
        try{
            /*
            $db = TkDbAdapter::getWorkConnection();
            $query = $db->createQuery()
            ->update('GEP_ATIVIDADE')
            ->set('DTFIMPLANEJADO', '\''.$dtfimplanejado.'\'')
            ->addWhere('NRATIVIDADE  = '.'\''.$nratividade.'\'');
            $row = $db->execute($query);
            */
            $sql = "UPDATE GEP_ATIVIDADE
                    SET DTFIMPLANEJADO = '$dtfimplanejado'
                    WHERE NRATIVIDADE = '$nratividade'";
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);

        }

        catch (Exception $e) {

            throw new Exception($e->getMessage());
            //            showClassError($e, __FUNCTION__, __LINE__);
        }

        if ($row instanceof Doctrine_Adapter_Statement) {
        	return true;
        } else {
        	return false;
        }
    }


    public function setUp()
    {
        parent::setUp();
        $this->hasMany('GepItemtrabalhoativ', array(
             'local' => 				array(
				 0 => 'NRATIVIDADE',
				 1 => 'NRORG',
				),
             'foreign' => 				array(
				 0 => 'NRATIVIDADE',
				 1 => 'NRORG',
				)));
    }

}